package org.wfc.file.controller;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.multipart.MultipartFile;
import org.wfc.common.core.domain.R;
import org.wfc.common.core.utils.file.FileUtils;
import org.wfc.file.service.ISysFileService;
import org.wfc.file.service.LocalSysFileServiceImpl.FileUploadResult;
import org.wfc.system.api.domain.SysFile;

/**
 * 文件请求处理
 * 
 * @author wfc
 */
@RestController
public class SysFileController {
    private static final Logger log = LoggerFactory.getLogger(SysFileController.class);

    @Autowired
    private ISysFileService sysFileService;

    /**
     * 文件上传请求
     */
    @PostMapping("upload")
    public R<SysFile> upload(MultipartFile file) {
        try {
            // 上传并返回访问地址
            FileUploadResult urlResult = sysFileService.uploadFile(file);
            SysFile sysFile = new SysFile();
            sysFile.setName(FileUtils.getName(urlResult.getUrl()));
            sysFile.setName(FileUtils.getName(urlResult.getLocalUrl()));
            sysFile.setName(FileUtils.getName(urlResult.getGatewayUrl()));
            sysFile.setUrl(urlResult.getUrl());
            sysFile.setLocalUrl(urlResult.getLocalUrl());
            sysFile.setGatewayUrl(urlResult.getGatewayUrl());
            return R.ok(sysFile);
        } catch (Exception e) {
            log.error("Failed to upload file", e);
            return R.fail(e.getMessage());
        }
    }
}